const cv = require('opencv4nodejs');

module.exports = {
  convertImageToMat: function(image) {
    return cv.imdecode(image)
  },
  convertMatToBW: function(mat) {
    mat = mat.cvtColor(cv.COLOR_RGB2GRAY)
    var bwMat = mat.threshold(196, 255, cv.THRESH_BINARY)
    module.exports.saveImage('./images/BWImg.png', bwMat)
    return bwMat
  },

  openMat: function(myMat) {
    const anchor = new cv.Point(-1,-1);
    const borderType = cv.BORDER_CONSTANT;
    const kernel = new cv.Mat(5, 3, cv.CV_8U);
    const morphedMat = myMat.morphologyEx(kernel, 2, anchor, 1, borderType)
    return morphedMat
  },

  convertMatToImage: function(mat) {
    return cv.imencode('.jpg', mat);
  },
  //Could be useful for creating presentation material
  saveImage: function(path, mat) {
    console.log(`Saving Image`)
    cv.imwrite(path, mat);
  },

  openImage: function(image) {
    console.log("Image Processing Started")
    var myMat = module.exports.convertImageToMat(image);
    var bwMat = module.exports.convertMatToBW(myMat)
    module.exports.saveImage('./images/raw.png', myMat)
    myMat = module.exports.openMat(bwMat)
    module.exports.saveImage('./images/img.png', myMat)
    console.log("Image Processing Finished")
    return module.exports.convertMatToImage(myMat)

  }
}
