module.exports = {
  //This should isolate lines that we want to present
  //Should make it less strict, maybe to needing a number and a decimal
  //To prevent bad OCR from killing off our chances of detecting stuff
  //ideal would be splitting the photo so that it can get restricted to
  //a character whitelist only allowing digits and .'s
  hasPrice: function(line) {
    // console.log(`In hasPrice`)
    // console.log(`line: ${line}`)
    if(line) {
      var matches = line.match(/\d*(\.\d{1,2})/);
      return matches != null
    }
    else {
      return false
    }
  },
  isPrice: function(line) {
    // console.log(`In hasPrice`)
    // console.log(`line: ${line}`)
    if(line) {
      var matches = line.match(/^\d+(\.\d{1,2})$/);
      return matches != null
    }
    else {
      return false
    }
  },

  //The meta lines shouldn't be categorized
  //This should also work by making sure it is in the meta blocks
  //Don't want to mach anything with total in it.
  isMeta: function(line) {
    return (line.includes("TAX") ||
      line.includes("COUNTY") ||
      line.includes("TOTAL") ||
      line.includes("SUBTOTAL") ||
      line.includes("TIP") ||
      line.includes("0.00") ||
      line.includes("-"))
      //change this to be an actual function, to prevent dashes from FP excluding the thing.
  },

  findStartOfItems: function(lines) {
    var i = 0
    while(!module.exports.hasPrice(lines[i].text) && i < lines.length - 1) {
      i++
    }
    return i
  },
  //goes until it finds two non-end line items, or the end of the string
  //TODO talk to will about idea related to This
  //user draws boxes on items and costs, machine learn on the images to get better
  //at automating the drawing.
  findEndOfItems: function(lines, startInd) {
    var i = startInd
    var wasLastItem = true
    while((module.exports.hasPrice(lines[i].text) || wasLastItem) &&  i < lines.length - 1) {
      wasLastItem = module.exports.hasPrice(lines[i].text)
      i++
    }
    if(wasLastItem) {
      return i
    } else {
      return i-1
    }
  },

  cleanReceipt: function(lines) {
    var receipt = {}
    var items = []
    var start = 0
    var end = lines.length - 1
    var order = 0
    console.log(`start: ${start} end: ${end}`)
    for (i = start; i <= end; i++) {
      var line = lines[i]
       var item = {name: ''}
       if(line  && module.exports.hasPrice(line.text)) {
         console.log(line.text)
         for( var word of line.words) {
           if(module.exports.hasPrice(word.text)){
             item.price = word.text
             break;
           } else {
             item.name = item.name + word.text + " "
           }
         }
         //remove the last space in the name
         item.name = item.name.substring(0, item.name.length - 1)
         item.order = order
         items.push(item)
         order++
       }
     }

     receipt.items = items
     //should get the location somewhere in this
     return receipt
  }
}
