
const _ALL_CATEGORIES = 'categories'
const DEFAULT_CATEGORIES =
  [
    {
      title: 'uncategorized',
      color: '#ccc'
    },
    {
      title: 'Food',
      color: '#FFA8A8'
    },
    {
      title: 'Home Goods',
      color: '#9588EC'
    },
    {
      title: 'Recreation',
      color: '#C4ABFE'
    }
  ]

export default class Category {
  constructor (title, color) {
    this.title = title
    this.color = color
  }

  commitTo (ls) {
    if (!Category.enumerateAll(ls).map(e => e.title).includes(this.title)) {
      const tmpIndex = JSON.parse(ls.get(_ALL_CATEGORIES, '[]'))
      tmpIndex.push({title: this.title, color: this.color})
      ls.set(_ALL_CATEGORIES, JSON.stringify(tmpIndex))
    }
  }

  static getFrom (ls, title) {
    const stored = this.enumerateAll(ls)
    if (!stored) {
      return new Category('', '#ccc')
    }
    for (let category of stored) {
      if (category.title === title) {
        return new Category(category.title, category.color)
      }
    }
    return new Category('uncategorized', '#ccc')
  }

  static getColorFromTitle (ls, title) {
    const category = this.getFrom(ls, title)
    if (!category) {
      return '#ccc'
    }
    return category.color
  }

  static enumerateAll (ls) {
    const stored = JSON.parse(ls.get(_ALL_CATEGORIES))
    if (!Array.isArray(stored)) {
      ls.set(_ALL_CATEGORIES, JSON.stringify(DEFAULT_CATEGORIES))
      return DEFAULT_CATEGORIES
    }
    if (stored.length === 0) {
      ls.set(_ALL_CATEGORIES, JSON.stringify(DEFAULT_CATEGORIES))
      return DEFAULT_CATEGORIES
    }
    return stored
  }
}
