
import { shallow } from '@vue/test-utils'
import CategoryEntry from '@/components/CategoryEntry'

const wrapperFactory = () =>  {
  return shallow(CategoryEntry, {
    attachToDocument: true
  })
}


describe('CategoryEntry.vue', () => {
  it('should render correct contents', () => {
    const wrapper = wrapperFactory()
    const title = 'foo'
    const color = '#123456'
    wrapper.setProps({
      title,
      color
    })
    expect(wrapper.find('.category-title').text()).toEqual(title)
  })
  it('should emit categoryselected on button click', () => {
    const wrapper = wrapperFactory()
    const title = 'foo'
    const color = '#123456'
    wrapper.setProps({
      title,
      color
    })
    wrapper.find('.btn').trigger('click')
    expect(wrapper.emitted().categoryselected).toEqual([[{
      title,
      color
    }]])
  })
})

