
import { shallow } from '@vue/test-utils'
import CategorySidebar from '@/components/CategorySidebar'

const wrapperFactory = () => {
  return shallow(CategorySidebar,{
    attachToDocument: true,
    // stubs: ['category-entry']
  })
}

describe('CategorySidebar.vue', () => {
  it('should render correct contents', () => {
    const wrapper = wrapperFactory()
    const categories = [
      {title: 'foo', color: '#123456'},
      {title: 'bar', color: '#ABCDEFG'}
    ]
    wrapper.setProps({
      categories
    })
    expect(wrapper.findAll('.category').length).toBe(categories.length)
  })
})

