import jest from 'jest'
import { shallow } from '@vue/test-utils'
import TakePhoto from '@/components/TakePhoto'

const wrapperFactory = () => {
  return shallow(TakePhoto, {
    attachToDocument: true
  })
}

describe('TakePhoto.vue', () => {
  it('should render correct contents', () => {
    const wrapper = wrapperFactory()
    expect(wrapper.find('.rg-uppy').isVisible()).toBe(true)
    wrapper.vm.error = true
    expect(wrapper.find('.alert.alert-danger').isVisible()).toBe(true)
    wrapper.vm.imgForPainting = 'foo'
    expect(wrapper.find('.paint-wrapper').isVisible()).toBe(true)
  })
  it('should acquire an image when the button is pressed', () => {
    const wrapper = wrapperFactory()
    wrapper.find('.rg-uppy').trigger('click')
    expect(wrapper.vm.uppy.getPlugin('Dashboard').isModalOpen()).toBe(true)
  })
  it
})

