#!/usr/bin/env python36
from os import walk
import os.path



def test_for(component):
    return f"""
import {{ shallow }} from '@vue/test-utils'
import {component} from '@/components/{component}'

describe('{component}.vue', () => {{
  it('should render correct contents', () => {{
    const wrapper = shallow({component})
    expect(wrapper).toEqual(null)
  }})
}})
    """

def write_test(component):
    if not os.path.exists(f'test/unit/specs/{component}.spec.js'):
        with open(f'test/unit/specs/{component}.spec.js', 'wt') as f:
            f.write(test_for(component))

def main():
    for dirpath, dirnames, filenames in walk('src'):
        for filename in filenames:
            if filename.endswith('.vue'):
                component = filename[:-4]
                write_test(component)

if __name__ == '__main__':
    main()
